% p40.m - eigenvalues of Orr-Sommerfeld operator (compare p38.m)
%Baseflow  U=1-x^2    U''=-2
  R = ??; 
  clf, [ay,ax] = meshgrid([.56 .04],[.1 .5]);
  for N = 40:20:100

    % D2=2nd-order differentiation matrix:
    % D2^2=4th-order differentiation matrix:
    [D,x] = cheb(N); D2 = D^2; 
    D2 = D2(2:N,2:N);  %Boundary conditions imposed on D2
    S = diag([0; 1 ./(1-x(2:N).^2); 0]);
    D4 = (diag(1-x.^2)*D^4 - 8*diag(x)*D^3 - 12*D^2)*S;
    D4 = D4(2:N,2:N);  %Boundary conditions imposed on D4

    % Orr-Sommerfeld operators A,B and generalized eigenvalues:
    I = eye(N-1);
    U=diag(1-x(2:N).^2);
    d2U=-2;
    A = ??;
    B = ??;
    [V,ee] = eig(A,B);
    i = N/20-1; subplot('position',[ax(i) ay(i) .38 .38])
    plot(diag(ee),'.','markersize',16)
    grid on, axis([-.8 .2 -1 0]), axis square
    title(['N = ' int2str(N) '    \lambda_{max} = ' ...
        num2str(max(real(diag(ee))),'%16.12f')]), drawnow
  end
  %Critical eigenvector
  figure(2)
  [maximeig,numcrit]=max(real(diag(ee)));
  vector=real(V(:,numcrit));
  vectoram=[0 vector' 0]'
  plot(-vectoram,x)
  title(['EIGENVECTOR'  '    \lambda_{max} = ' ...
        num2str(max(real(diag(ee))),'%16.12f')]), drawnow
  